import { AbstractOutputComponent, AbstractOutputProps, AbstractOutputState } from './abstract-output-component';
import * as React from 'react';
import { ItemParams } from 'react-contexify';
import { Entry } from 'tsp-typescript-client/lib/models/entry';
import { ResponseStatus } from 'tsp-typescript-client/lib/models/response/responses';
import ColumnHeader from './utils/filter-tree/column-header';
import '../../style/react-contextify.css';
declare type DataTreeOutputProps = AbstractOutputProps & {};
declare type DataTreeOuputState = AbstractOutputState & {
    selectedSeriesId: number[];
    xyTree: Entry[];
    collapsedNodes: number[];
    orderedNodes: number[];
    columns: ColumnHeader[];
};
export declare class DataTreeOutputComponent extends AbstractOutputComponent<AbstractOutputProps, DataTreeOuputState> {
    treeRef: React.RefObject<HTMLDivElement>;
    private _debouncedFetchSelectionData;
    constructor(props: AbstractOutputProps);
    componentDidMount(): void;
    fetchTree(): Promise<ResponseStatus>;
    resultsAreEmpty(): boolean;
    renderTree(): React.ReactNode | undefined;
    renderMainArea(): React.ReactNode;
    renderContextMenu(): React.ReactNode;
    protected handleItemClick: (args: ItemParams) => void;
    setFocus(): void;
    private onContextMenu;
    private doContextMenu;
    getMenuPosition(event: React.MouseEvent<HTMLDivElement>): {
        x: number;
        y: number;
    };
    private onToggleCollapse;
    private onOrderChange;
    protected waitAnalysisCompletion(): Promise<void>;
    componentWillUnmount(): void;
    protected fetchSelectionData(): Promise<void>;
    componentDidUpdate(prevProps: DataTreeOutputProps): Promise<void>;
    private exportOutput;
    protected showAdditionalOptions(): React.ReactNode;
    private tryFetchDataTree;
}
export {};
//# sourceMappingURL=datatree-output-component.d.ts.map