import { ICellRendererParams, IFloatingFilterParams } from 'ag-grid-community';
import * as React from 'react';
declare type CellRendererProps = ICellRendererParams & {
    filterModel: Map<string, string>;
    searchResultsColor: string;
};
declare type SearchFilterRendererProps = IFloatingFilterParams & {
    onFilterChange: (colName: string, filterValue: string) => void;
    onclickNext: () => void;
    onclickPrevious: () => void;
    colName: string;
    filterModel: Map<string, string>;
};
interface SearchFilterRendererState {
    hasHovered: boolean;
    hasClicked: boolean;
}
export declare class LoadingRenderer extends React.Component<ICellRendererParams> {
    render(): JSX.Element;
}
export declare class CellRenderer extends React.Component<CellRendererProps> {
    render(): JSX.Element;
}
export declare class SearchFilterRenderer extends React.Component<SearchFilterRendererProps, SearchFilterRendererState> {
    private debouncedChangeHandler;
    constructor(props: SearchFilterRendererProps);
    render(): JSX.Element;
    private onKeyDownEvent;
    private onInputBoxChanged;
    private onMouseEnterHandler;
    private onMouseLeaveHandler;
    private onClickHandler;
    private onDownClickHandler;
    private onUpClickHandler;
    private onCloseClickHandler;
}
export {};
//# sourceMappingURL=table-renderer-components.d.ts.map